"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("underscore");
const mongoose = require("mongoose");
const utils_1 = require("@nodeswork/utils");
const sMongoose = require("../mongoose");
const TimerangeSchema = new mongoose.Schema({
    start: {
        type: Number,
        default: Date.now,
    },
    end: {
        type: Number,
        default: Date.now,
    },
}, { _id: false, id: false });
class MetricsModel extends sMongoose.Model {
    // public static async upsertMetrics(
    // options: SetMetricsOptions,
    // ) : Promise<MetricsModel> {
    // const data = m.operator.updateMetricsData(
    // options.dimensions, options.name, options.value,
    // );
    // const updateDoc: { [name: string]: any; } = {};
    // for (const dhash of Object.keys(data.dimensions)) {
    // updateDoc[`dimensions.${dhash}`] = data.dimensions[dhash];
    // }
    // for (const mName of Object.keys(data.metrics)) {
    // const mValues = data.metrics[mName];
    // for (const dhash of Object.keys(mValues)) {
    // updateDoc[`metrics.${mName}.${dhash}`] = mValues[dhash];
    // }
    // }
    // const self = this.cast<MetricsModel>();
    // return await self.findByIdAndUpdate(options.id, { $set: updateDoc }, {
    // new:     true,
    // upsert:  true,
    // });
    // }
    appendMetrics(options) {
        utils_1.metrics.operator.updateMetricsData(options, this);
        this.markModified('dimensions');
        this.markModified('metrics');
    }
    static async appendMetrics(options) {
        const self = this.cast();
        const metrics = await self.findById(options.id);
        if (metrics == null) {
            return await this.createMetrics({ metrics: [options] });
        }
        else {
            utils_1.metrics.operator.updateMetricsData(options);
            return await metrics.save();
        }
    }
    static async createMetrics(options) {
        const self = this.cast();
        const doc = _.extend({}, options.doc, {
            dimensions: {},
            metrics: {},
        });
        if (options.ts) {
            doc.timerange = { start: options.ts, end: options.ts };
        }
        if (options.metrics && options.metrics.length) {
            for (const mo of options.metrics) {
                utils_1.metrics.operator.updateMetricsData(mo, doc);
            }
        }
        return (await self.create(doc));
    }
    static async searchMetrics(options) {
        const self = this.cast();
        const query = _.extend({}, options.query);
        const project = _.extend({}, options.project);
        const dimensions = _.flatten([options.dimensions || []]);
        const metricsNames = _.flatten([options.metrics || []]);
        query['timerange.start'] = {
            $gte: options.timerange.start,
            $lt: options.timerange.end,
        };
        project.timerange = 1;
        project.dimensions = 1;
        if (metricsNames.length > 0) {
            for (const mName of metricsNames) {
                project[`metrics.${mName}`] = 1;
            }
        }
        const result = await self.find(query, project, options.queryOptions);
        for (const v of result) {
            _.defaults(v, { dimensions: {}, metrics: {} });
            const nd = utils_1.metrics.operator.projectMetricsData(v, {
                dimensions,
                metrics: metricsNames,
            });
            _.extend(v, nd);
        }
        return result;
    }
    static async aggregateMetrics(options) {
        const metricsModels = await this.searchMetrics(options);
        return utils_1.metrics.operator.mergeMetricsDataByTimeGranularity(metricsModels, options.granularityInSecond);
    }
}
__decorate([
    sMongoose.Field({
        type: TimerangeSchema,
        default: TimerangeSchema,
    }),
    __metadata("design:type", Object)
], MetricsModel.prototype, "timerange", void 0);
__decorate([
    sMongoose.Field({
        type: mongoose.Schema.Types.Mixed,
        default: {},
    }),
    __metadata("design:type", Object)
], MetricsModel.prototype, "dimensions", void 0);
__decorate([
    sMongoose.Field({
        type: mongoose.Schema.Types.Mixed,
        default: {},
    }),
    __metadata("design:type", Object)
], MetricsModel.prototype, "metrics", void 0);
exports.MetricsModel = MetricsModel;

//# sourceMappingURL=metrics-models.js.map
